## sonivoxeas 1.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9)
project( EASSynth
         VERSION 1.3.0
         DESCRIPTION "Sonivox EAS for Linux and Qt" )

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt5 COMPONENTS Core Gui Widgets REQUIRED)
find_package(Drumstick 2.0 COMPONENTS ALSA REQUIRED)
find_package(PkgConfig REQUIRED)
pkg_check_modules(PULSE REQUIRED libpulse-simple)

include(GNUInstallDirs)

add_subdirectory(sonivox)
add_subdirectory(libsvoxeas)
add_subdirectory(cmdlnsynth)
add_subdirectory(guisynth)

=== cmdlnsynth/CMakeLists.txt ===
add_executable( cmdlnsynth main.cpp )

target_link_libraries( cmdlnsynth
    Qt5::Core
    Drumstick::ALSA
    svoxeas
)

target_compile_definitions( cmdlnsynth PRIVATE
    VERSION=${PROJECT_VERSION}
    $<$<CONFIG:RELEASE>:QT_NO_DEBUG_OUTPUT>
)

install( TARGETS cmdlnsynth 
         DESTINATION ${CMAKE_INSTALL_BINDIR} )

=== guisynth/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set( SOURCES main.cpp mainwindow.cpp )
set( HEADERS mainwindow.h )
set( FORMS mainwindow.ui )
set( RESOURCES guisynth.qrc )

add_executable( guisynth
  ${SOURCES}
  ${HEADERS}
  ${FORMS}
  ${RESOURCES}
)

target_link_libraries( guisynth
  Qt5::Widgets
  Drumstick::ALSA
  svoxeas
)

target_compile_definitions( guisynth PRIVATE
    VERSION=${PROJECT_VERSION}
    $<$<CONFIG:RELEASE>:QT_NO_DEBUG_OUTPUT>
)

install( TARGETS guisynth 
         DESTINATION ${CMAKE_INSTALL_BINDIR} )

=== libsvoxeas/CMakeLists.txt ===
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set( HEADERS
    programsettings.h
    synthcontroller.h
    synthrenderer.h
)

set( SOURCES
    programsettings.cpp
    synthcontroller.cpp 
    synthrenderer.cpp
    filewrapper.cpp
)

add_library( svoxeas SHARED ${HEADERS} ${SOURCES} )

set_target_properties( svoxeas PROPERTIES 
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

target_link_libraries( svoxeas 
    PUBLIC
        sonivox
    PRIVATE
        Qt5::Core
        Drumstick::ALSA
        ${PULSE_LIBRARIES}
)

target_include_directories( svoxeas
    PUBLIC 
      ${CMAKE_CURRENT_SOURCE_DIR}
    PRIVATE 
      ${PULSE_INCLUDE_DIRS}
)

target_compile_definitions( svoxeas PRIVATE
    VERSION=${PROJECT_VERSION}
    $<$<CONFIG:RELEASE>:QT_NO_DEBUG_OUTPUT>
)

install( TARGETS svoxeas
         DESTINATION ${CMAKE_INSTALL_LIBDIR} )

install ( FILES ${HEADERS}
          DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} )

=== sonivox/CMakeLists.txt ===
add_definitions(
  -DUNIFIED_DEBUG_MESSAGES
  -DEAS_WT_SYNTH 
#_IMELODY_PARSER 
#_RTTTL_PARSER 
#_OTA_PARSER 
#_XMF_PARSER 
  -DNUM_OUTPUT_CHANNELS=2 
  -D_SAMPLE_RATE_22050 
  -DMAX_SYNTH_VOICES=64 
  -D_16_BIT_SAMPLES 
  -D_FILTER_ENABLED 
  -DDLS_SYNTHESIZER 
  -D_REVERB_ENABLED 
  -D_CHORUS_ENABLED
)

set( SOURCES
  host_src/eas_config.c 
  host_src/eas_hostmm.c 
#host_src/eas_main.c 
  host_src/eas_report.c 
  host_src/eas_wave.c 
  lib_src/eas_chorus.c 
  lib_src/eas_chorusdata.c 
  lib_src/eas_data.c 
  lib_src/eas_dlssynth.c 
  lib_src/eas_flog.c 
#lib_src/eas_ima_tables.c 
#lib_src/eas_imaadpcm.c 
#lib_src/eas_imelody.c 
#lib_src/eas_imelodydata.c 
  lib_src/eas_math.c 
  lib_src/eas_mdls.c 
  lib_src/eas_midi.c 
  lib_src/eas_mididata.c 
  lib_src/eas_mixbuf.c 
  lib_src/eas_mixer.c 
#lib_src/eas_ota.c 
#lib_src/eas_otadata.c 
  lib_src/eas_pan.c 
  lib_src/eas_pcm.c 
  lib_src/eas_pcmdata.c 
  lib_src/eas_public.c 
  lib_src/eas_reverb.c 
  lib_src/eas_reverbdata.c 
#lib_src/eas_rtttl.c 
#lib_src/eas_rtttldata.c 
  lib_src/eas_smf.c 
  lib_src/eas_smfdata.c 
  lib_src/eas_tcdata.c 
  lib_src/eas_tonecontrol.c 
  lib_src/eas_voicemgt.c 
#lib_src/eas_wavefile.c 
#lib_src/eas_wavefiledata.c 
  lib_src/eas_wtengine.c 
  lib_src/eas_wtsynth.c 
#lib_src/eas_xmf.c 
#lib_src/eas_xmfdata.c 
  lib_src/jet.c 
  lib_src/wt_22khz.c 
)

add_library( sonivox STATIC ${SOURCES} )

target_include_directories( sonivox 
  PUBLIC host_src
  PRIVATE lib_src
)

set_target_properties( sonivox PROPERTIES 
  POSITION_INDEPENDENT_CODE true
  VERSION 3.6.10 
)

=== debian/changelog ===
sonivoxeas (1.3.0-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 18 Jan 2021 14:05:10 +0100

=== debian/control ===
Source: sonivoxeas
Section: sound
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://github.com/pedrolcl/Linux-SonivoxEas
Rules-Requires-Root: no
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, libasound2-dev,
 libdrumstick-dev (>= 1:2.0.0~), qtbase5-dev, libpulse-dev

Package: sonivoxeas-gui
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: sonivoxeas
Description: Sonivox EAS for Linux and Qt
 A Linux MIDI Synth library based on the Sonivox EAS Synthesizer published
 by Google on the Android Open Source Project. It is a real time GM
 synthesizer without needing external soundfonts, using embedded samples
 instead. It consumes very little resources, so it may be indicated in
 Linux projects for small embedded devices.
 .
 Package with the Qt5 graphique interface.

Package: sonivoxeas-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Sonivox EAS for Linux
 A Linux MIDI Synth library based on the Sonivox EAS Synthesizer published
 by Google on the Android Open Source Project. It is a real time GM
 synthesizer without needing external soundfonts, using embedded samples
 instead. It consumes very little resources, so it may be indicated in
 Linux projects for small embedded devices.
 .
 Package with the command line version.

Package: libsvoxeas1
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Linux synthesizer shared library, using ALSA Sequencer and PulseAudio
 A Linux MIDI Synth library based on the Sonivox EAS Synthesizer published
 by Google on the Android Open Source Project. It is a real time GM
 synthesizer without needing external soundfonts, using embedded samples
 instead. It consumes very little resources, so it may be indicated in
 Linux projects for small embedded devices.
 .
 This package contains the runtime files.

Package: libsvoxeas-dev
Architecture: any
Section: libdevel
Multi-Arch: same
Depends: libsvoxeas1 (= ${binary:Version}), ${misc:Depends}
Description: Linux synthesizer shared library, using ALSA Sequencer and PulseAudio
 A Linux MIDI Synth library based on the Sonivox EAS Synthesizer published
 by Google on the Android Open Source Project. It is a real time GM
 synthesizer without needing external soundfonts, using embedded samples
 instead. It consumes very little resources, so it may be indicated in
 Linux projects for small embedded devices.
 .
 This package contains the development files.
